-- ALU32 Testbench
-- Author: John Moskal
-- Modifications:
--
------------------------------------------------------------------------------------------

library work;
LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
USE ieee.std_logic_arith.all;

entity toplevel is
end toplevel;

architecture struct of toplevel is

component ALU32 is
port
(
        A, B:           in std_logic_vector(31 downto 0);
        SL:             in std_logic_vector(2 downto 0);
        R:              out std_logic_vector(31 downto 0);
        Z, V, C:        out std_logic
);
end component;               

signal A, B, R:         std_logic_vector(31 downto 0);
signal OP:              std_logic_vector(2 downto 0);
signal Z, V, C:         std_logic;  
begin

dut: ALU32 port map(A, B, OP, R, Z, V, C);

process
begin

A <= "10101010101010101010101010101010";
B <= "01010101010101010101010101010101";

-- AND
OP <= "000";
wait for 10 ns;

-- OR
OP <= "001";
wait for 10 ns;

-- ADD
OP <= "010";
wait for 10 ns;

-- SUB
OP <= "110";
wait for 10 ns;

-- SLT
OP <= "111";
wait for 10 ns;

----------------------------------------

A <= "11001100110011001100110011001100"; 
B <= "01100110011001100110011001100110"; 

-- AND
OP <= "000";
wait for 10 ns;

-- OR
OP <= "001";
wait for 10 ns;

-- ADD
OP <= "010";
wait for 10 ns;

-- SUB
OP <= "110";
wait for 10 ns;

-- SLT
OP <= "111";
wait for 10 ns;

----------------------------------------

A <= "00000000000000000000000000000000";
B <= "00000000000000000000000000000000";
OP <= "000";

wait for 10 ns;

end process;
end struct;



