-- Clockgen
-- Author: John Moskal
-- Modifications:
--
------------------------------------------------------------------------------------------

library work;
LIBRARY ieee;
USE ieee.std_logic_1164.ALL;

entity clockgen is 
port
( 
num:   out integer; 
clk:   out std_logic;
rst:   out std_logic
); 
end clockgen; 

architecture stuff of clockgen is 

signal   clock:      std_logic :='0';
signal   reset:      std_logic :='1';
constant HalfPeriod: time      := 5 ns;

begin 

process
begin
   clock <= not clock ;
   wait for HalfPeriod;
end process;

process(clock)
variable count: integer :=-1;
begin
   if (clock'event and clock='1') then
       count := count+1;
   end if;

   num <= count;

   if (count<=0 or (count=1 and clock='1')) then
       reset <= '1';
   else
       reset <= '0';
   end if;
       
end process;

clk <= clock and not reset;
rst <= reset;

end stuff; 

