-- ULP Adder (Based on CLA)
-- Author: John Moskal
--  Created: 11-27-04
-- Modified: 11-27-04
--
-- Modifications:
--
------------------------------------------------------------------------------------------

library work;
library ieee;
use ieee.std_logic_1164.all;

entity ulpadd32 is
port
(
   A:             in std_logic_vector(31 downto 0);
   cin:             in std_logic;
   Result:          out std_logic_vector(31 downto 0)
);
end entity ulpadd32;

architecture stuff of ulpadd32 is

---------------------------------------------------------

component SRFA is
port
(
   A: in std_logic;
   cin: in std_logic;
   p: out std_logic;
   R:   out std_logic
);
end component SRFA;

component SBCLG is
port
(
   p:        in std_logic_vector(3 downto 0);
   c0:       in std_logic;
   c1,c2,c3: out std_logic;
   PP:       out std_logic
);
end component SBCLG;

-- SIGNALS --
signal cin_w: std_logic_vector(31 downto 0);
signal p_w: std_logic_vector(31 downto 0);
signal p2_w: std_logic_vector(7 downto 0);
signal p3_w: std_logic_vector(1 downto 0);

begin

cin_w(00) <= cin;

RA00:   SRFA port map(A(00), cin_w(00), p_w(00), Result(00));
RA01:   SRFA port map(A(01), cin_w(01), p_w(01), Result(01));
RA02:   SRFA port map(A(02), cin_w(02), p_w(02), Result(02));
RA03:   SRFA port map(A(03), cin_w(03), p_w(03), Result(03));

RA04:   SRFA port map(A(04), cin_w(04), p_w(04), Result(04));
RA05:   SRFA port map(A(05), cin_w(05), p_w(05), Result(05));
RA06:   SRFA port map(A(06), cin_w(06), p_w(06), Result(06));
RA07:   SRFA port map(A(07), cin_w(07), p_w(07), Result(07));

RA08:   SRFA port map(A(08), cin_w(08), p_w(08), Result(08));
RA09:   SRFA port map(A(09), cin_w(09), p_w(09), Result(09));
RA10:   SRFA port map(A(10), cin_w(10), p_w(10), Result(10));
RA11:   SRFA port map(A(11), cin_w(11), p_w(11), Result(11));

RA12:   SRFA port map(A(12), cin_w(12), p_w(12), Result(12));
RA13:   SRFA port map(A(13), cin_w(13), p_w(13), Result(13));
RA14:   SRFA port map(A(14), cin_w(14), p_w(14), Result(14));
RA15:   SRFA port map(A(15), cin_w(15), p_w(15), Result(15));

RA16:   SRFA port map(A(16), cin_w(16), p_w(16), Result(16));
RA17:   SRFA port map(A(17), cin_w(17), p_w(17), Result(17));
RA18:   SRFA port map(A(18), cin_w(18), p_w(18), Result(18));
RA19:   SRFA port map(A(19), cin_w(19), p_w(19), Result(19));

RA20:   SRFA port map(A(20), cin_w(20), p_w(20), Result(20));
RA21:   SRFA port map(A(21), cin_w(21), p_w(21), Result(21));
RA22:   SRFA port map(A(22), cin_w(22), p_w(22), Result(22));
RA23:   SRFA port map(A(23), cin_w(23), p_w(23), Result(23));

RA24:   SRFA port map(A(24), cin_w(24), p_w(24), Result(24));
RA25:   SRFA port map(A(25), cin_w(25), p_w(25), Result(25));
RA26:   SRFA port map(A(26), cin_w(26), p_w(26), Result(26));
RA27:   SRFA port map(A(27), cin_w(27), p_w(27), Result(27));

RA28:   SRFA port map(A(28), cin_w(28), p_w(28), Result(28));
RA29:   SRFA port map(A(29), cin_w(29), p_w(29), Result(29));
RA30:   SRFA port map(A(30), cin_w(30), p_w(30), Result(30));
RA31:   SRFA port map(A(31), cin_w(31), p_w(31), Result(31));

L100:   SBCLG port map(p_w(03 downto 00), cin_w(00), cin_w(01), cin_w(02), cin_w(03), p2_w(0));
L101:   SBCLG port map(p_w(07 downto 04), cin_w(04), cin_w(05), cin_w(06), cin_w(07), p2_w(1));
L102:   SBCLG port map(p_w(11 downto 08), cin_w(08), cin_w(09), cin_w(10), cin_w(11), p2_w(2));
L103:   SBCLG port map(p_w(15 downto 12), cin_w(12), cin_w(13), cin_w(14), cin_w(15), p2_w(3));
L104:   SBCLG port map(p_w(19 downto 16), cin_w(16), cin_w(17), cin_w(18), cin_w(19), p2_w(4));
L105:   SBCLG port map(p_w(23 downto 20), cin_w(20), cin_w(21), cin_w(22), cin_w(23), p2_w(5));
L106:   SBCLG port map(p_w(27 downto 24), cin_w(24), cin_w(25), cin_w(26), cin_w(27), p2_w(6));
L107:   SBCLG port map(p_w(31 downto 28), cin_w(28), cin_w(29), cin_w(30), cin_w(31), p2_w(7));

L200:   SBCLG port map(p2_w(03 downto 0),  cin_w(00), cin_w(04), cin_w(08), cin_w(12), p3_w(0));
L201:   SBCLG port map(p2_w(07 downto 4),  cin_w(16), cin_w(20), cin_w(24), cin_w(28), p3_w(1));

cin_w(16) <= p3_w(0) and cin_w(00);

end stuff;

------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------



