-------------------------------------------------------------------------------
-- File name : pc_plus1.vhd
-- Title     : Program counter
-- project   : ECE 485
-- Library   : single-cycle processor
-- Author(s) : James E. Stine, Jr.
-- Purpose   : definition of single-cycle processor
-- notes :   

-- Copyright Illinois Institute of Technology
-------------------------------------------------------------------------------

library ieee;
use ieee.std_logic_1164.all;

entity pc_plus1 is
  port(a : in  std_logic_vector(8 downto 0);
       r : out std_logic_vector(8 downto 0));
end pc_plus1;

architecture structure of pc_plus1 is

  component halfadder is
    port (a    : in  std_logic;
          b    : in  std_logic;
          sum  : out std_logic;
          cout : out std_logic);
  end component;

  signal c_out : std_logic_vector(7 downto 0);

begin
	
  ha0  : halfadder port map(a(0), '1', r(0), c_out(0));  
  ha1  : halfadder port map(a(1), c_out(0), r(1), c_out(1));
  ha2  : halfadder port map(a(2), c_out(1), r(2), c_out(2));
  ha3  : halfadder port map(a(3), c_out(2), r(3), c_out(3));
  ha4  : halfadder port map(a(4), c_out(3), r(4), c_out(4));
  ha5  : halfadder port map(a(5), c_out(4), r(5), c_out(5));
  ha6  : halfadder port map(a(6), c_out(5), r(6), c_out(6));
  ha7  : halfadder port map(a(7), c_out(6), r(7), c_out(7));
  ha8  : halfadder port map(a(8), c_out(7), r(8));
  
end structure;
